/**
 * Based on examples in
 *     Head First Object-Oriented Analysis and Design
 *     by Brett D. McLaughlin, Gary Pollice, and David West
 *     O'Reilly, 2007
 *     ISBN 978-0-596-00867-3
 *
 * Ported from Java by
 *     Ronald Mak
 *     Department of Computer Engineering
 *     San Jose State University
 *     San Jose, CA  95192
 */
#ifndef WOOD_H_
#define WOOD_H_

#include <iostream>
using namespace std;

enum class Wood
{
    INDIAN_ROSEWOOD, BRAZILIAN_ROSEWOOD, MAHOGANY, MAPLE,
    COCOBOLO, CEDAR, ADIRONDACK, ALDER, SITKA,
};

inline ostream& operator <<(ostream& ostr, const Wood wood)
{
    switch (wood)
    {
        case Wood::INDIAN_ROSEWOOD:    ostr << "Indian Rosewood";     break;
        case Wood::BRAZILIAN_ROSEWOOD: ostr << "Brazilian Rosewood";  break;
        case Wood::MAHOGANY:           ostr << "Mahogany";            break;
        case Wood::MAPLE:              ostr << "Maple";               break;
        case Wood::COCOBOLO:           ostr << "Cocobolo";            break;
        case Wood::CEDAR:              ostr << "Cedar";               break;
        case Wood::ADIRONDACK:         ostr << "Adirondack";          break;
        case Wood::ALDER:              ostr << "Alder";               break;
        case Wood::SITKA:              ostr << "Sitka";               break;
        default:                       ostr << "unspecified";
    }
    return ostr;
}

#endif /* WOOD_H_ */
